package org.springblade.person.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.person.entity.Drug;
import org.springblade.person.vo.DrugVO;
import org.springblade.person.wrapper.DrugWrapper;
import org.springblade.person.service.IDrugService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-28
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/drug")

public class DrugClient implements IDrugClient {

    private final IDrugService drugService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public DrugVO detail(@SpringQueryMap Drug drug) {
        Drug detail = drugService.getOne(Condition.getQueryWrapper(drug));
        return DrugWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<DrugVO> list(Drug drug) {
        return DrugWrapper.build().listVO(drugService.list(Condition.getQueryWrapper(drug)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Drug drug) {
        return drugService.save(drug);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Drug drug) {
        return drugService.updateById(drug);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Drug drug) {
        return drugService.saveOrUpdate(drug);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return drugService.deleteLogic(Func.toLongList(ids));
        }


}
